OpenShot Audio Library | OpenShotAudio: juce::BufferedInputStream Class Reference

OpenShot Audio Library | OpenShotAudio 1.0.0

Loading...
Searching...
No Matches
juce::BufferedInputStream Class Reference

`#include <juce_BufferedInputStream.h>`

Inheritance diagram for juce::BufferedInputStream:

## Public Member Functions
| BufferedInputStream (InputStream *sourceStream, int bufferSize, bool deleteSourceWhenDestroyed)
| BufferedInputStream (InputStream &sourceStream, int bufferSize)
| ~BufferedInputStream () override
char | peekByte ()
int64 | getTotalLength () override
int64 | getPosition () override
bool | setPosition (int64 newPosition) override
int | read (void *destBuffer, int maxBytesToRead) override
String | readString () override
bool | isExhausted () override
Public Member Functions inherited from juce::InputStream
virtual | ~InputStream ()=default
int64 | getNumBytesRemaining ()
ssize_t | read (void *destBuffer, size_t maxBytesToRead)
virtual char | readByte ()
virtual bool | readBool ()
virtual short | readShort ()
virtual short | readShortBigEndian ()
virtual int | readInt ()
virtual int | readIntBigEndian ()
virtual int64 | readInt64 ()
virtual int64 | readInt64BigEndian ()
virtual float | readFloat ()
virtual float | readFloatBigEndian ()
virtual double | readDouble ()
virtual double | readDoubleBigEndian ()
virtual int | readCompressedInt ()
virtual String | readNextLine ()
virtual String | readEntireStreamAsString ()
virtual size_t | readIntoMemoryBlock (MemoryBlock &destBlock, ssize_t maxNumBytesToRead=-1)
virtual void | skipNextBytes (int64 numBytesToSkip)

## Detailed Description

Wraps another input stream, and reads from it using an intermediate buffer

If you're using an input stream such as a file input stream, and making lots of small read accesses to it, it's probably sensible to wrap it in one of these, so that the source stream gets accessed in larger chunk sizes, meaning less work for the underlying stream.

Definition at line 36 of file juce_BufferedInputStream.h.

## Constructor & Destructor Documentation

## ◆ BufferedInputStream() [1/2]

juce::BufferedInputStream::BufferedInputStream | ( | InputStream * | sourceStream,
|  | int | bufferSize,
|  | bool | deleteSourceWhenDestroyed )

Creates a BufferedInputStream from an input source.

Parameters

  sourceStream | the source stream to read from
  bufferSize | the size of reservoir to use to buffer the source
  deleteSourceWhenDestroyed | whether the sourceStream that is passed in should be deleted by this object when it is itself deleted.

Definition at line 41 of file juce_BufferedInputStream.cpp.

Referenced by BufferedInputStream(), juce::ZipFile::createStreamForEntry(), and ~BufferedInputStream().

## ◆ BufferedInputStream() [2/2]

juce::BufferedInputStream::BufferedInputStream | ( | InputStream & | sourceStream,
|  | int | bufferSize )

Creates a BufferedInputStream from an input source.

Parameters

  sourceStream | the source stream to read from - the source stream must not be deleted until this object has been destroyed.
  bufferSize | the size of reservoir to use to buffer the source

Definition at line 50 of file juce_BufferedInputStream.cpp.

## ◆ ~BufferedInputStream()

juce::BufferedInputStream::~BufferedInputStream | ( |  | ) |
| overridedefault

Destructor.

This may also delete the source stream, if that option was chosen when the buffered stream was created.

## Member Function Documentation

## ◆ getPosition()

int64 juce::BufferedInputStream::getPosition | ( |  | ) |
| overridevirtual

Returns the offset of the next byte that will be read from the stream.

See also
  setPosition

Implements juce::InputStream.

Definition at line 71 of file juce_BufferedInputStream.cpp.

Referenced by BufferedInputStream(), and ~BufferedInputStream().

## ◆ getTotalLength()

int64 juce::BufferedInputStream::getTotalLength | ( |  | ) |
| overridevirtual

Returns the total number of bytes available for reading in this stream.

Note that this is the number of bytes available from the start of the stream, not from the current position.

If the size of the stream isn't actually known, this will return -1.

See also
  getNumBytesRemaining

Implements juce::InputStream.

Definition at line 66 of file juce_BufferedInputStream.cpp.

Referenced by ~BufferedInputStream().

## ◆ isExhausted()

bool juce::BufferedInputStream::isExhausted | ( |  | ) |
| overridevirtual

Returns true if the stream has no more data to read.

Implements juce::InputStream.

Definition at line 82 of file juce_BufferedInputStream.cpp.

Referenced by ~BufferedInputStream().

## ◆ peekByte()

char juce::BufferedInputStream::peekByte | ( |  | ) |

Returns the next byte that would be read by a call to readByte()

Definition at line 58 of file juce_BufferedInputStream.cpp.

Referenced by ~BufferedInputStream().

## ◆ read()

int juce::BufferedInputStream::read | ( | void * | destBuffer,
|  | int | maxBytesToRead )
| overridevirtual

Reads some data from the stream into a memory buffer.

This is the only read method that subclasses actually need to implement, as the InputStream base class implements the other read methods in terms of this one (although it's often more efficient for subclasses to implement them directly).

Parameters

  destBuffer | the destination buffer for the data. This must not be null.
  maxBytesToRead | the maximum number of bytes to read - make sure the memory block passed in is big enough to contain this many bytes. This value must not be negative.

Returns
  the actual number of bytes that were read, which may be less than maxBytesToRead if the stream is exhausted before it gets that far

Implements juce::InputStream.

Definition at line 133 of file juce_BufferedInputStream.cpp.

Referenced by ~BufferedInputStream().

## ◆ readString()

String juce::BufferedInputStream::readString | ( |  | ) |
| overridevirtual

Reads a zero-terminated UTF-8 string from the stream.

This will read characters from the stream until it hits a null character or end-of-stream.

See also
  OutputStream::writeString, readEntireStreamAsString

Reimplemented from juce::InputStream.

Definition at line 162 of file juce_BufferedInputStream.cpp.

Referenced by ~BufferedInputStream().

## ◆ setPosition()

bool juce::BufferedInputStream::setPosition | ( | int64 | newPosition | ) |
| overridevirtual

Tries to move the current read position of the stream.

The position is an absolute number of bytes from the stream's start.

Some streams might not be able to do this, in which case they should do nothing and return false. Others might be able to manage it by resetting themselves and skipping to the correct position, although this is obviously a bit slow.

Returns
  true if the stream manages to reposition itself correctly

See also
  getPosition

Implements juce::InputStream.

Definition at line 76 of file juce_BufferedInputStream.cpp.

Referenced by ~BufferedInputStream().

The documentation for this class was generated from the following files:

- juce_BufferedInputStream.h
- juce_BufferedInputStream.cpp